package macros;

import haxe.macro.ComplexTypeTools;
import haxe.macro.TypeTools;
import haxe.macro.Expr.Position;
import haxe.macro.Expr.ComplexType;
import haxe.macro.Context;
import haxe.macro.Type;

class Helper {
	public static function resolveType(t:ComplexType, pos:Position):Null<ComplexType> {
		if (t == null)
			return null;
		return TypeTools.toComplexType(Context.resolveType(t, pos));
	}

	public static function newPromise(t:ComplexType):ComplexType {
		if (Helper.isVoidC(t)) {
			return TPath({name: "Promise", params: [TPType(TPath({name: "Noise", pack: ["tink", "core"]}))], pack: ["tink", "core"]});
		}

		return TPath({name: "Promise", params: [TPType(t)], pack: ["tink", "core"]});
	}

	public static function isVoidC(t:ComplexType):Bool {
		switch (t) {
			case TPath(p):
				return (p.name == "Void");
			default:
				return false;
		}
	}

	public static function isVoid(t:Type) {
		switch (t) {
			case TAbstract(t, _):
				return (t.get().name == "Void");
			default:
				return false;
		}
	}

	public static function isPromise(t:Type):Bool {
		return switch (t) {
			case TType(t, params):
				t.toString() == "tink.Promise";
			default:
				false;
		}
	}

	public static function getPromiseType(t:ComplexType):Type {
		switch (ComplexTypeTools.toType(t)) {
			case TType(t, params):
				return params[0];
			case _:
				return null;
		}
	}
}
